//     Backbone.js 0.3.3
//     (c) 2010 Jeremy Ashkenas, DocumentCloud Inc.
//     Backbone may be freely distributed under the MIT license.
//     For all details and documentation:
//     http://documentcloud.github.com/backbone
(function(){var a;typeof exports!=="undefined"?a=exports:a=this.Backbone={},a.VERSION="0.3.3";var b=this._;!b&&typeof require!=="undefined"&&(b=require("underscore")._);var c=this.jQuery||this.Zepto;a.emulateHTTP=false,a.emulateJSON=false,a.Events={bind:function(a,b){var c=this._callbacks||(this._callbacks={}),d=this._callbacks[a]||(this._callbacks[a]=[]);d.push(b);return this},unbind:function(a,b){var c;if(a){if(c=this._callbacks)if(b){var d=c[a];if(!d)return this;for(var e=0,f=d.length;e<f;e++)if(b===d[e]){d.splice(e,1);break}}else c[a]=[]}else this._callbacks={};return this},trigger:function(a){var b,c,d,e;if(!(c=this._callbacks))return this;if(b=c[a])for(d=0,e=b.length;d<e;d++)b[d].apply(this,Array.prototype.slice.call(arguments,1));if(b=c.all)for(d=0,e=b.length;d<e;d++)b[d].apply(this,arguments);return this}},a.Model=function(a,c){a||(a={}),this.defaults&&(a=b.extend({},this.defaults,a)),this.attributes={},this._escapedAttributes={},this.cid=b.uniqueId("c"),this.set(a,{silent:true}),this._previousAttributes=b.clone(this.attributes),c&&c.collection&&(this.collection=c.collection),this.initialize(a,c)},b.extend(a.Model.prototype,a.Events,{_previousAttributes:null,_changed:false,initialize:function(){},toJSON:function(){return b.clone(this.attributes)},get:function(a){return this.attributes[a]},escape:function(a){var b;if(b=this._escapedAttributes[a])return b;var c=this.attributes[a];return this._escapedAttributes[a]=p(c==null?"":c)},set:function(a,c){c||(c={});if(!a)return this;a.attributes&&(a=a.attributes);var d=this.attributes,e=this._escapedAttributes;if(!c.silent&&this.validate&&!this._performValidation(a,c))return false;"id"in a&&(this.id=a.id);for(var f in a){var g=a[f];b.isEqual(d[f],g)||(d[f]=g,delete e[f],c.silent||(this._changed=true,this.trigger("change:"+f,this,g,c)))}!c.silent&&this._changed&&this.change(c);return this},unset:function(a,b){b||(b={});var c=this.attributes[a],d={};d[a]=void 0;if(!b.silent&&this.validate&&!this._performValidation(d,b))return false;delete this.attributes[a],delete this._escapedAttributes[a],b.silent||(this._changed=true,this.trigger("change:"+a,this,void 0,b),this.change(b));return this},clear:function(a){a||(a={});var b=this.attributes,c={};for(attr in b)c[attr]=void 0;if(!a.silent&&this.validate&&!this._performValidation(c,a))return false;this.attributes={},this._escapedAttributes={};if(!a.silent){this._changed=true;for(attr in b)this.trigger("change:"+attr,this,void 0,a);this.change(a)}return this},fetch:function(b){b||(b={});var c=this,d=function(a){if(!c.set(c.parse(a),b))return false;b.success&&b.success(c,a)},e=o(b.error,c,b);(this.sync||a.sync)("read",this,d,e);return this},save:function(b,c){c||(c={});if(b&&!this.set(b,c))return false;var d=this,e=function(a){if(!d.set(d.parse(a),c))return false;c.success&&c.success(d,a)},f=o(c.error,d,c),g=this.isNew()?"create":"update";(this.sync||a.sync)(g,this,e,f);return this},destroy:function(b){b||(b={});var c=this,d=function(a){c.collection&&c.collection.remove(c),b.success&&b.success(c,a)},e=o(b.error,c,b);(this.sync||a.sync)("delete",this,d,e);return this},url:function(){var a=n(this.collection);if(this.isNew())return a;return a+(a.charAt(a.length-1)=="/"?"":"/")+this.id},parse:function(a){return a},clone:function(){return new this.constructor(this)},isNew:function(){return!this.id},change:function(a){this.trigger("change",this,a),this._previousAttributes=b.clone(this.attributes),this._changed=false},hasChanged:function(a){if(a)return this._previousAttributes[a]!=this.attributes[a];return this._changed},changedAttributes:function(a){a||(a=this.attributes);var c=this._previousAttributes,d=false;for(var e in a)b.isEqual(c[e],a[e])||(d=d||{},d[e]=a[e]);return d},previous:function(a){if(!a||!this._previousAttributes)return null;return this._previousAttributes[a]},previousAttributes:function(){return b.clone(this._previousAttributes)},_performValidation:function(a,b){var c=this.validate(a);if(c){b.error?b.error(this,c):this.trigger("error",this,c,b);return false}return true}}),a.Collection=function(a,c){c||(c={}),c.comparator&&(this.comparator=c.comparator,delete c.comparator),this._boundOnModelEvent=b.bind(this._onModelEvent,this),this._reset(),a&&this.refresh(a,{silent:true}),this.initialize(a,c)},b.extend(a.Collection.prototype,a.Events,{model:a.Model,initialize:function(){},toJSON:function(){return this.map(function(a){return a.toJSON()})},add:function(a,c){if(b.isArray(a))for(var d=0,e=a.length;d<e;d++)this._add(a[d],c);else this._add(a,c);return this},remove:function(a,c){if(b.isArray(a))for(var d=0,e=a.length;d<e;d++)this._remove(a[d],c);else this._remove(a,c);return this},get:function(a){if(a==null)return null;return this._byId[a.id!=null?a.id:a]},getByCid:function(a){return a&&this._byCid[a.cid||a]},at:function(a){return this.models[a]},sort:function(a){a||(a={});if(!this.comparator)throw new Error("Cannot sort a set without a comparator");this.models=this.sortBy(this.comparator),a.silent||this.trigger("refresh",this,a);return this},pluck:function(a){return b.map(this.models,function(b){return b.get(a)})},refresh:function(a,b){a||(a=[]),b||(b={}),this._reset(),this.add(a,{silent:true}),b.silent||this.trigger("refresh",this,b);return this},fetch:function(b){b||(b={});var c=this,d=function(a){c.refresh(c.parse(a)),b.success&&b.success(c,a)},e=o(b.error,c,b);(this.sync||a.sync)("read",this,d,e);return this},create:function(b,c){var d=this;c||(c={}),b instanceof a.Model?b.collection=d:b=new this.model(b,{collection:d});var e=function(a,b){d.add(a),c.success&&c.success(a,b)};return b.save(null,{success:e,error:c.error})},parse:function(a){return a},chain:function(){return b(this.models).chain()},_reset:function(a){this.length=0,this.models=[],this._byId={},this._byCid={}},_add:function(b,c){c||(c={}),b instanceof a.Model||(b=new this.model(b,{collection:this}));var d=this.getByCid(b);if(d)throw new Error(["Can't add the same model to a set twice",d.id]);this._byId[b.id]=b,this._byCid[b.cid]=b,b.collection=this;var e=this.comparator?this.sortedIndex(b,this.comparator):this.length;this.models.splice(e,0,b),b.bind("all",this._boundOnModelEvent),this.length++,c.silent||b.trigger("add",b,this,c);return b},_remove:function(a,b){b||(b={}),a=this.getByCid(a)||this.get(a);if(!a)return null;delete this._byId[a.id],delete this._byCid[a.cid],delete a.collection,this.models.splice(this.indexOf(a),1),this.length--,b.silent||a.trigger("remove",a,this,b),a.unbind("all",this._boundOnModelEvent);return a},_onModelEvent:function(a,b){a==="change:id"&&(delete this._byId[b.previous("id")],this._byId[b.id]=b),this.trigger.apply(this,arguments)}});var d=["forEach","each","map","reduce","reduceRight","find","detect","filter","select","reject","every","all","some","any","include","invoke","max","min","sortBy","sortedIndex","toArray","size","first","rest","last","without","indexOf","lastIndexOf","isEmpty"];b.each(d,function(c){a.Collection.prototype[c]=function(){return b[c].apply(b,[this.models].concat(b.toArray(arguments)))}}),a.Controller=function(a){a||(a={}),a.routes&&(this.routes=a.routes),this._bindRoutes(),this.initialize(a)};var e=/:([\w\d]+)/g,f=/\*([\w\d]+)/g;b.extend(a.Controller.prototype,a.Events,{initialize:function(){},route:function(c,d,e){a.history||(a.history=new a.History),b.isRegExp(c)||(c=this._routeToRegExp(c)),a.history.route(c,b.bind(function(a){var b=this._extractParameters(c,a);e.apply(this,b),this.trigger.apply(this,["route:"+d].concat(b))},this))},saveLocation:function(b){a.history.saveLocation(b)},_bindRoutes:function(){if(!this.routes)return;for(var a in this.routes){var b=this.routes[a];this.route(a,b,this[b])}},_routeToRegExp:function(a){a=a.replace(e,"([^/]*)").replace(f,"(.*?)");return new RegExp("^"+a+"$")},_extractParameters:function(a,b){return a.exec(b).slice(1)}}),a.History=function(){this.handlers=[],this.fragment=this.getFragment(),b.bindAll(this,"checkUrl")};var g=/^#*/;b.extend(a.History.prototype,{interval:50,getFragment:function(a){return(a||window.location).hash.replace(g,"")},start:function(){var a=document.documentMode,b=c.browser.msie&&(!a||a<=7);b&&(this.iframe=c("<iframe src=\"javascript:0\" tabindex=\"-1\" />").hide().appendTo("body")[0].contentWindow),"onhashchange"in window&&!b?c(window).bind("hashchange",this.checkUrl):setInterval(this.checkUrl,this.interval);return this.loadUrl()},route:function(a,b){this.handlers.push({route:a,callback:b})},checkUrl:function(){var a=this.getFragment();a==this.fragment&&this.iframe&&(a=this.getFragment(this.iframe.location));if(a==this.fragment||a==decodeURIComponent(this.fragment))return false;this.iframe&&(window.location.hash=this.iframe.location.hash=a),this.loadUrl()},loadUrl:function(){var a=this.fragment=this.getFragment(),c=b.any(this.handlers,function(b){if(b.route.test(a)){b.callback(a);return true}});return c},saveLocation:function(a){a=(a||"").replace(g,"");if(this.fragment==a)return;window.location.hash=this.fragment=a,this.iframe&&a!=this.getFragment(this.iframe.location)&&(this.iframe.document.open().close(),this.iframe.location.hash=a)}}),a.View=function(a){this._configure(a||{}),this._ensureElement(),this.delegateEvents(),this.initialize(a)};var h=function(a){return c(a,this.el)},i=/^(\w+)\s*(.*)$/;b.extend(a.View.prototype,a.Events,{tagName:"div",$:h,initialize:function(){},render:function(){return this},remove:function(){c(this.el).remove();return this},make:function(a,b,d){var e=document.createElement(a);b&&c(e).attr(b),d&&c(e).html(d);return e},delegateEvents:function(a){if(!(a||(a=this.events)))return;c(this.el).unbind();for(var d in a){var e=a[d],f=d.match(i),g=f[1],h=f[2],j=b.bind(this[e],this);h===""?c(this.el).bind(g,j):c(this.el).delegate(h,g,j)}},_configure:function(a){this.options&&(a=b.extend({},this.options,a)),a.model&&(this.model=a.model),a.collection&&(this.collection=a.collection),a.el&&(this.el=a.el),a.id&&(this.id=a.id),a.className&&(this.className=a.className),a.tagName&&(this.tagName=a.tagName),this.options=a},_ensureElement:function(){if(this.el)return;var a={};this.id&&(a.id=this.id),this.className&&(a["class"]=this.className),this.el=this.make(this.tagName,a)}});var j=function(a,b){var c=m(this,a,b);c.extend=j;return c};a.Model.extend=a.Collection.extend=a.Controller.extend=a.View.extend=j;var k={create:"POST",update:"PUT","delete":"DELETE",read:"GET"};a.sync=function(b,d,e,f){var g=k[b],h=b==="create"||b==="update"?JSON.stringify(d.toJSON()):null,i={url:n(d),type:g,contentType:"application/json",data:h,dataType:"json",processData:false,success:e,error:f};a.emulateJSON&&(i.contentType="application/x-www-form-urlencoded",i.processData=true,i.data=h?{model:h}:{});if(a.emulateHTTP)if(g==="PUT"||g==="DELETE")a.emulateJSON&&(i.data._method=g),i.type="POST",i.beforeSend=function(a){a.setRequestHeader("X-HTTP-Method-Override",g)};c.ajax(i)};var l=function(){},m=function(a,c,d){var e;c&&c.hasOwnProperty("constructor")?e=c.constructor:e=function(){return a.apply(this,arguments)},l.prototype=a.prototype,e.prototype=new l,c&&b.extend(e.prototype,c),d&&b.extend(e,d),e.prototype.constructor=e,e.__super__=a.prototype;return e},n=function(a){if(!(a&&a.url))throw new Error("A 'url' property or function must be specified");return b.isFunction(a.url)?a.url():a.url},o=function(a,b,c){return function(d){a?a(b,d):b.trigger("error",b,d,c)}},p=function(a){return a.replace(/&(?!\w+;)/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;")}})()