/*
 * Copyright (C) 2007 Apple Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  Neither the name of Apple Computer, Inc. ("Apple") nor the names of
 *     its contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE AND ITS CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL APPLE OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/String.sprintf=function(e){return String.vsprintf(e,Array.prototype.slice.call(arguments,1))},String.tokenizeFormatString=function(e){function r(e){t.push({type:"string",value:e})}function i(e,n,r){t.push({type:"specifier",specifier:e,precision:n,substitutionIndex:r})}var t=[],n=0,s=0;for(var o=e.indexOf("%",s);o!==-1;o=e.indexOf("%",s)){r(e.substring(s,o)),s=o+1;if(e[s]==="%"){r("%"),++s;continue}if(!isNaN(e[s])){var u=parseInt(e.substring(s));while(!isNaN(e[s]))++s;u>0&&e[s]==="$"&&(n=u-1,++s)}var a=-1;if(e[s]==="."){++s,a=parseInt(e.substring(s)),isNaN(a)&&(a=0);while(!isNaN(e[s]))++s}i(e[s],a,n),++n,++s}return r(e.substring(s)),t},String.standardFormatters={d:function(e){return typeof e=="object"&&Object.proxyType(e)==="number"&&(e=e.description),e=parseInt(e),isNaN(e)?0:e},f:function(e,t){return typeof e=="object"&&Object.proxyType(e)==="number"&&(e=e.description),e=parseFloat(e),e&&t.precision>-1&&(e=e.toFixed(t.precision)),isNaN(e)?t.precision>-1?Number(0).toFixed(t.precision):0:e},s:function(e){return typeof e=="object"&&Object.proxyType(e)!=="null"&&(e=e.description),e}},String.vsprintf=function(e,t){return String.format(e,t,String.standardFormatters,"",function(e,t){return e+t}).formattedResult},String.format=function(e,t,n,r,i){function s(){return'String.format("'+e+'", "'+t.join('", "')+'")'}function o(e){console.warn(s()+": "+e)}function u(e){console.error(s()+": "+e)}if(!e||!t||!t.length)return{formattedResult:i(r,e),unusedSubstitutions:t};var a=r,f=String.tokenizeFormatString(e),l={};for(var c=0;c<f.length;++c){var h=f[c];if(h.type==="string"){a=i(a,h.value);continue}if(h.type!=="specifier"){u('Unknown token type "'+h.type+'" found.');continue}if(h.substitutionIndex>=t.length){u("not enough substitution arguments. Had "+t.length+" but needed "+(h.substitutionIndex+1)+", so substitution was skipped."),a=i(a,"%"+(h.precision>-1?h.precision:"")+h.specifier);continue}l[h.substitutionIndex]=!0;if(!(h.specifier in n)){o("unsupported format character “"+h.specifier+"”. Treating as a string."),a=i(a,t[h.substitutionIndex]);continue}a=i(a,n[h.specifier](t[h.substitutionIndex],h))}var p=[];for(var c=0;c<t.length;++c){if(c in l)continue;p.push(t[c])}return{formattedResult:a,unusedSubstitutions:p}},Number.bytesToString=function(e,t,n){t||(t=String.sprintf),typeof n=="undefined"&&(n=!0);if(e<1024)return t("%.0fB",e);var r=e/1024;if(n&&r<1024)return t("%.2fKB",r);if(r<1024)return t("%.0fKB",r);var i=r/1024;return n?t("%.2fMB",i):t("%.0fMB",i)},ResourceCategory=function(e,t,n){this.name=e,this.title=t,this.color=n},ResourceCategory.prototype={toString:function(){return this.title}},SummaryBar=function(e){this.categories=e,this.element=document.createElement("div"),this.element.className="summary-bar",this.graphElement=document.createElement("canvas"),this.graphElement.setAttribute("width","450"),this.graphElement.setAttribute("height","38"),this.graphElement.className="summary-graph",this.element.appendChild(this.graphElement),this.legendElement=document.createElement("div"),this.legendElement.className="summary-graph-legend",this.element.appendChild(this.legendElement)},SummaryBar.prototype={reset:function(){this.legendElement.removeChildren(),this._drawSummaryGraph()},update:function(e,t,n){var r=t(e),i=[];for(var s in this.categories){var o=r.categoryValues[s];if(!o)continue;var u=this.categories[s].color,a={color:u,value:o};i.push(a);var f=this._makeLegendElement(this.categories[s].title,n(o),u);this.legendElement.appendChild(f)}if(r.total){var l=this._makeLegendElement("Total",n(r.total));l.addStyleClass("total"),this.legendElement.appendChild(l)}this._drawSummaryGraph(i)},_drawSwatch:function(e,t){function r(){n.fillStyle=t,n.fillRect(0,0,13,13);var e=n.createLinearGradient(0,0,13,13);e.addColorStop(0,"rgba(255, 255, 255, 0.2)"),e.addColorStop(1,"rgba(255, 255, 255, 0.0)"),n.fillStyle=e,n.fillRect(0,0,13,13),e=n.createLinearGradient(13,13,0,0),e.addColorStop(0,"rgba(0, 0, 0, 0.2)"),e.addColorStop(1,"rgba(0, 0, 0, 0.0)"),n.fillStyle=e,n.fillRect(0,0,13,13),n.strokeStyle="rgba(0, 0, 0, 0.6)",n.strokeRect(.5,.5,12,12)}var n=e.getContext("2d");n.clearRect(0,0,13,24),r(),n.save(),n.translate(0,25),n.scale(1,-1),r(),n.restore(),this._fadeOutRect(n,0,13,13,13,.5,0)},_drawSummaryGraph:function(e){function c(){s.beginPath(),s.moveTo(o+4,u+f-3-.5),s.lineTo(o+a-4,u+f-3-.5),s.closePath(),s.save(),s.shadowBlur=2,s.shadowColor="rgba(0, 0, 0, 0.5)",s.shadowOffsetX=3,s.shadowOffsetY=5,s.strokeStyle="white",s.lineWidth=1,s.stroke(),s.shadowOffsetX=-3,s.stroke(),s.restore(),s.save(),s.globalCompositeOperation="destination-out",s.strokeStyle="rgba(0, 0, 0, 1)",s.lineWidth=1,s.stroke(),s.restore()}function h(){s.beginPath(),s.moveTo(o,u+l),s.lineTo(o,u+f-l),s.arc(o+l,u+f-l,l,Math.PI,Math.PI/2,!0),s.lineTo(o+a-l,u+f),s.arc(o+a-l,u+f-l,l,Math.PI/2,0,!0),s.lineTo(o+a,u+l),s.arc(o+a-l,u+l,l,0,3*Math.PI/2,!0),s.lineTo(o+l,u),s.arc(o+l,u+l,l,Math.PI/2,Math.PI,!0),s.closePath(),s.save(),s.clip();var t=0;for(var n=0;n<e.length;++n){var i=Math.round(a*r[n]/100);s.fillStyle=e[n].color,s.fillRect(o+t,u,i,f),t+=i}s.lineWidth=1;for(var n=1;n<20;++n)s.beginPath(),s.moveTo(o+n*Math.round(a/20)+.5,u),s.lineTo(o+n*Math.round(a/20)+.5,u+f),s.closePath(),s.strokeStyle="rgba(0, 0, 0, 0.2)",s.stroke(),s.beginPath(),s.moveTo(o+n*Math.round(a/20)+1.5,u),s.lineTo(o+n*Math.round(a/20)+1.5,u+f),s.closePath(),s.strokeStyle="rgba(255, 255, 255, 0.2)",s.stroke();var c=s.createLinearGradient(o,u,o,u+f/1.5);c.addColorStop(0,"rgba(220, 220, 220, 0.6)"),c.addColorStop(.4,"rgba(220, 220, 220, 0.2)"),c.addColorStop(1,"rgba(255, 255, 255, 0.0)");var h=s.createLinearGradient(o,u+f/3,o,u+f);h.addColorStop(0,"rgba(0, 0, 0, 0.0)"),h.addColorStop(.8,"rgba(0, 0, 0, 0.2)"),h.addColorStop(1,"rgba(0, 0, 0, 0.5)"),s.fillStyle=h,s.fillRect(o,u,a,f),s.fillStyle=c,s.fillRect(o,u,a,f),s.restore()}!e||!e.length?(e=[{color:"white",value:1}],this._showingEmptySummaryGraph=!0):delete this._showingEmptySummaryGraph;var t=0;for(var n=0;n<e.length;++n)t+=e[n].value;var r=e.map(function(e){return Math.max(Math.round(100*e.value/t),1)}),i=0;for(var n=0;n<r.length;++n)i+=r[n];while(i>100)for(var n=0;n<r.length&&i>100;++n)r[n]>1&&(--r[n],--i);while(i<100)for(var n=0;n<r.length&&i<100;++n)++r[n],++i;var s=this.graphElement.getContext("2d"),o=0,u=0,a=450,f=19,l=f/2;s.clearRect(o,u,a,f*2),c(),h(),s.save(),s.translate(0,f*2+1),s.scale(1,-1),h(),s.restore(),this._fadeOutRect(s,o,u+f+1,a,f,.5,0)},_fadeOutRect:function(e,t,n,r,i,s,o){e.save();var u=e.createLinearGradient(t,n,t,n+i);u.addColorStop(0,"rgba(0, 0, 0, "+(1-s)+")"),u.addColorStop(.8,"rgba(0, 0, 0, "+(1-o)+")"),u.addColorStop(1,"rgba(0, 0, 0, 1.0)"),e.globalCompositeOperation="destination-out",e.fillStyle=u,e.fillRect(t,n,r,i),e.restore()},_makeLegendElement:function(e,t,n){var r=document.createElement("label");r.className="summary-graph-legend-item";if(n){var i=document.createElement("canvas");i.className="summary-graph-legend-swatch",i.setAttribute("width","13"),i.setAttribute("height","24"),r.appendChild(i),this._drawSwatch(i,n)}var s=document.createElement("div");s.className="summary-graph-legend-label",r.appendChild(s);var o=document.createElement("div");o.className="summary-graph-legend-header",o.textContent=e,s.appendChild(o);var u=document.createElement("div");return u.className="summary-graph-legend-value",u.textContent=t,s.appendChild(u),r.addStyleClass=function(e){e&&!this.hasStyleClass(e)&&(this.className+=this.className.length?" "+e:e)},r.hasStyleClass=function(e){if(!e)return!1;if(this.className===e)return!0;var t=this.className.indexOf(e);if(t===-1)return!1;var n=" "+this.className+" ";return n.indexOf(" "+e+" ",t)!==-1},r}};